# CodecLz4

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaio.github.io/CodecLz4.jl/stable)
[![Latest](https://img.shields.io/badge/docs-latest-blue.svg)](https://juliaio.github.io/CodecLz4.jl/latest)
[![Build Status](https://github.com/JuliaIO/CodecLz4.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/JuliaIO/CodecLz4.jl/actions/workflows/CI.yml)
[![CodeCov](https://codecov.io/gh/JuliaIO/CodecLz4.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaIO/CodecLz4.jl)

Provides transcoding codecs for compression and decompression with LZ4. Source: [LZ4](https://github.com/lz4/lz4)
The compression algorithm is similar to the compression available through [Blosc.jl](https://github.com/stevengj/Blosc.jl), but uses the LZ4 Frame format as opposed to the standard LZ4 or LZ4_HC formats.

Codecs for the standard LZ4 and LZ4_HC formats are also provided as `LZ4FastCompressor` and `LZ4HCCompressor`.
These codecs follow the [LZ4 streaming examples](https://github.com/lz4/lz4/tree/master/examples),
breaking the data into blocks and prepending each compressed block with a size.
Data compressed with these codecs can be decompressed with `LZ4SafeDecompressor`.
> [!CAUTION]
> `LZ4FastCompressor` and `LZ4HCCompressor` output is not compatible with lz4frame and is platform dependent.


Non-streaming functions are included via `lz4_compress`, `lz4_hc_compress`, and `lz4_decompress`.
These should work with most other standard lz4 implementations.

## Installation

```julia
Pkg.add("CodecLz4")
```

## Usage

```julia
using CodecLz4

# Some text.
text = """
Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean sollicitudin
mauris non nisi consectetur, a dapibus urna pretium. Vestibulum non posuere
erat. Donec luctus a turpis eget aliquet. Cras tristique iaculis ex, eu
malesuada sem interdum sed. Vestibulum ante ipsum primis in faucibus orci luctus
et ultrices posuere cubilia Curae; Etiam volutpat, risus nec gravida ultricies,
erat ex bibendum ipsum, sed varius ipsum ipsum vitae dui.
"""

# Streaming API.
stream = LZ4FrameCompressorStream(IOBuffer(text))
for line in eachline(LZ4FrameDecompressorStream(stream))
println(line)
end
close(stream)

# Array API.
compressed = transcode(LZ4FrameCompressor, text)
@assert sizeof(compressed) < sizeof(text)
@assert transcode(LZ4FrameDecompressor, compressed) == Vector{UInt8}(text)
```
The API is heavily based off of [CodecZLib](https://github.com/JuliaIO/CodecZlib.jl), and uses [TranscodingStreams.jl](https://github.com/JuliaIO/TranscodingStreams.jl). See those for details.

"""
    lz4_compress(input::Union{Vector{UInt8},Base.CodeUnits{UInt8}}, acceleration::Integer=0)

Compresses `input` using LZ4_compress_fast. Returns a Vector{UInt8} of the compressed data.
"""
function lz4_compress(
    input::Union{Vector{UInt8},Base.CodeUnits{UInt8}},
    acceleration::Integer=0
)
    bound = LZ4_compressBound(length(input))
    bound == 0 && throw(LZ4Exception(
        "lz4_compress",
        "Input size $(length(input)) greater than LZ4_MAX_INPUT_VALUE. Cannot encode as a single block."
    ))

    out_buffer = Vector{UInt8}(undef, bound)
    out_size = LZ4_compress_fast(pointer(input), pointer(out_buffer), length(input), bound, acceleration)
    resize!(out_buffer, out_size)
end

"""
    lz4_hc_compress(input::Union{Vector{UInt8},Base.CodeUnits{UInt8}}, acceleration::Integer=$LZ4HC_CLEVEL_DEFAULT)

Compresses `input` using LZ4_compress_HC. Returns a Vector{UInt8} of the compressed data.
"""
function lz4_hc_compress(
    input::Union{Vector{UInt8},Base.CodeUnits{UInt8}},
    compressionlevel::Integer=LZ4HC_CLEVEL_DEFAULT
)
    bound = LZ4_compressBound(length(input))
    bound == 0 && throw(LZ4Exception(
        "lz4_hc_compress",
        "Input size $(length(input)) greater than LZ4_MAX_INPUT_VALUE. Cannot encode as a single block."
    ))

    out_buffer = Vector{UInt8}(undef, bound)
    out_size = LZ4_compress_HC(pointer(input), pointer(out_buffer), length(input), bound, compressionlevel)
    resize!(out_buffer, out_size)
end

"""
    lz4_decompress(input::Union{Vector{UInt8},Base.CodeUnits{UInt8}}, expected_size::Integer=input.size * 2)

Decompresses `input` using LZ4_decompress_safe.
`expected_size` must be equal to or larger than the expected decompressed size of the input or decompression will fail.
Returns a Vector{UInt8} of the decompressed data.
"""
function lz4_decompress(
    input::Union{Vector{UInt8},Base.CodeUnits{UInt8}},
    expected_size::Integer=length(input) * 2
)
    out_buffer = Vector{UInt8}(undef, expected_size)
    out_size = LZ4_decompress_safe(pointer(input), pointer(out_buffer), length(input), expected_size)
    resize!(out_buffer, out_size)
end

__precompile__()
module CodecLz4

using Lz4_jll: liblz4
using TranscodingStreams
using TranscodingStreams: TranscodingStream, Memory, Error

export LZ4FrameCompressor, LZ4FrameCompressorStream,
    LZ4FrameDecompressor, LZ4FrameDecompressorStream,
    LZ4FastCompressor, LZ4FastCompressorStream,
    LZ4SafeDecompressor, LZ4SafeDecompressorStream,
    LZ4HCCompressor, LZ4HCCompressorStream,
    BlockSizeID, default_size, max64KB, max256KB, max1MB, max4MB,
    BlockMode, block_linked, block_independent,
    FrameType, normal_frame, skippable_frame,
    lz4_compress, lz4_hc_compress, lz4_decompress

struct LZ4Exception <: Exception
    src::AbstractString
    msg::AbstractString
end

Base.showerror(io::IO, ex::LZ4Exception) = print(io, "$(ex.src): $(ex.msg)")

include("headers/lz4frame.jl")
include("headers/lz4.jl")
include("headers/lz4hc.jl")
include("frame_compression.jl")
include("hc_compression.jl")
include("lz4_compression.jl")
include("simple_compression.jl")

end

using CodecLz4
using Test

@testset "CodecLz4.jl" begin
    include("gcsafe_ccall.jl")
    include("headers/lz4.jl")
    include("headers/lz4frame.jl")
    include("headers/lz4hc.jl")
    include("frame_compression.jl")
    include("hc_compression.jl")
    include("lz4_compression.jl")
    include("simple_compression.jl")
end

const CINT_SIZE = sizeof(Cint)

function writeint(mem::Memory, int::Cint)
    checkbounds(mem, sizeof(Cint))
    unsafe_store!(Ptr{Cint}(mem.ptr), int)
    return CINT_SIZE
end

function readint(mem::Memory)
    checkbounds(mem, sizeof(Cint))
    return unsafe_load(Ptr{Cint}(mem.ptr))
end

mutable struct SimpleDoubleBuffer
    buffer::Array{UInt8, 2}
    next::Bool
end

SimpleDoubleBuffer(buf_size::Integer) = SimpleDoubleBuffer(Array{UInt8}(undef, buf_size, 2), false)
function get_buffer!(db::SimpleDoubleBuffer)
    out_buffer = @view(db.buffer[:, db.next+1])
    db.next = !db.next  # Update index
    return out_buffer
end

function max_compressed_size(in_size::Integer, block_size::Integer)
    num_blocks = ceil(Int, in_size / block_size)
    compressed_size = LZ4_compressBound(block_size) + CINT_SIZE

    return compressed_size * num_blocks
end

mutable struct LZ4FastCompressor <: TranscodingStreams.Codec
    streamptr::Ptr{LZ4_stream_t}
    acceleration::Cint
    block_size::Int
    buffer::SimpleDoubleBuffer
end

"""
    LZ4FastCompressor(; kwargs...)

Creates an LZ4 compression codec.

# Keywords
- `acceleration::Integer=0`: acceleration factor
- `block_size::Integer=1024`: The size in bytes to encrypt into each block.
"""
function LZ4FastCompressor(; acceleration::Integer=0, block_size::Integer=1024)
    if block_size > LZ4_MAX_INPUT_SIZE
        throw(ArgumentError("`block_size` larger than $LZ4_MAX_INPUT_SIZE."))
    end

    return LZ4FastCompressor(C_NULL, acceleration, block_size, SimpleDoubleBuffer(block_size))
end

const LZ4FastCompressorStream{S} = TranscodingStream{LZ4FastCompressor,S} where S<:IO

"""
    LZ4FastCompressor(stream::IO; kwargs...)

Creates an LZ4 compression stream. See `LZ4FastCompressor()` and `TranscodingStream()` for arguments.
"""
function LZ4FastCompressorStream(stream::IO; kwargs...)
    x, y = splitkwargs(kwargs, (:acceleration, :block_size))
    return TranscodingStream(LZ4FastCompressor(; x...), stream; y...)
end

"""
    TranscodingStreams.expectedsize(codec::Union{LZ4FastCompressor, LZ4HCCompressor}, input::Memory)

Returns the expected size of the transcoded data.
"""
function TranscodingStreams.expectedsize(codec::LZ4FastCompressor, input::Memory)::Int
    max_compressed_size(length(input), codec.block_size)
end

"""
   TranscodingStreams.minoutsize(codec::Union{LZ4FastCompressor, LZ4HCCompressor}, input::Memory)

Returns the minimum output size of `process`.
"""
function TranscodingStreams.minoutsize(codec::LZ4FastCompressor, input::Memory)::Int
    LZ4_compressBound(length(input)) + CINT_SIZE
end

"""
   TranscodingStreams.initialize(codec::LZ4FastCompressor)

Initializes the LZ4 Compression Codec.
"""
function TranscodingStreams.initialize(codec::LZ4FastCompressor)::Nothing
    codec.streamptr = LZ4_createStream()
    nothing
end

"""
    TranscodingStreams.finalize(codec::LZ4FastCompressor)

Finalizes the LZ4 Compression Codec.
"""
function TranscodingStreams.finalize(codec::LZ4FastCompressor)::Nothing
    LZ4_freeStream(codec.streamptr)
    codec.streamptr = C_NULL
    nothing
end

"""
    TranscodingStreams.startproc(codec::LZ4FastCompressor, mode::Symbol, error::Error)

Starts processing with the codec
"""
function TranscodingStreams.startproc(
    codec::LZ4FastCompressor,
    mode::Symbol,
    error::Error
)::Symbol

    try
        LZ4_resetStream(codec.streamptr)
        :ok
    catch err
        error[] = err
        :error
    end
end

"""
    TranscodingStreams.process(codec::LZ4FastCompressor, input::Memory, output::Memory, error::Error)

Compresses the data from `input` and writes to `output`.
The process follows the compression example from
https://github.com/lz4/lz4/blob/dev/examples/blockStreaming_doubleBuffer.c
wherein each block of encoded data is prefixed by the number of bytes contained in that block.
Decoding can be done through the LZ4SafeDecompressor.
"""
function TranscodingStreams.process(
    codec::LZ4FastCompressor,
    input::Memory,
    output::Memory,
    error::Error
)::Tuple{Int,Int,Symbol}

    length(input) == 0 && return (0, 0, :end)
    try
        in_buffer = get_buffer!(codec.buffer)

        data_size = min(length(input), codec.block_size)
        out_buffer = Vector{UInt8}(undef, LZ4_compressBound(data_size))
        GC.@preserve in_buffer unsafe_copyto!(pointer(in_buffer), input.ptr, data_size)

        compressed_size = LZ4_compress_fast_continue(
            codec.streamptr,
            in_buffer,
            out_buffer,
            data_size,
            length(out_buffer),
            codec.acceleration,
        )

        checkbounds(output, compressed_size + CINT_SIZE)
        writeint(output, compressed_size)
        GC.@preserve out_buffer unsafe_copyto!(output.ptr + CINT_SIZE, pointer(out_buffer), compressed_size)

        return (data_size, compressed_size + CINT_SIZE, :ok)
    catch err
        error[] = err
        return (0, 0, :error)
    end
end

mutable struct LZ4SafeDecompressor <: TranscodingStreams.Codec
    streamptr::Ptr{LZ4_streamDecode_t}
    block_size::Int
    buffer::SimpleDoubleBuffer
end

"""
    LZ4SafeDecompressor(; kwargs...)

Creates an LZ4 compression codec.

# Keywords
- `block_size::Integer=1024`: The size in bytes of unecrypted data contained in each block.
    Must match or exceed the compression `block_size` or decompression will fail.
"""
function LZ4SafeDecompressor(; block_size::Integer=1024)
    return LZ4SafeDecompressor(C_NULL, block_size, SimpleDoubleBuffer(block_size))
end

const LZ4SafeDecompressorStream{S} = TranscodingStream{LZ4SafeDecompressor,S} where S<:IO

"""
    LZ4SafeDecompressorStream(stream::IO; kwargs...)

Creates an LZ4 compression stream. See `LZ4SafeDecompressor()` and `TranscodingStream()` for arguments.
"""
function LZ4SafeDecompressorStream(stream::IO; kwargs...)
    x, y = splitkwargs(kwargs, (:block_size,))
    return TranscodingStream(LZ4SafeDecompressor(; x...), stream; y...)
end

"""
    TranscodingStreams.expectedsize(codec::LZ4SafeDecompressor, input::Memory)

Returns the expected size of the transcoded data.
"""
function TranscodingStreams.expectedsize(codec::LZ4SafeDecompressor, input::Memory)::Int
    max(length(input) * 2, codec.block_size)
end

"""
   TranscodingStreams.minoutsize(codec::LZ4SafeDecompressor, input::Memory)

Returns the minimum output size of `process`.
"""
function TranscodingStreams.minoutsize(codec::LZ4SafeDecompressor, input::Memory)::Int
    max(length(input) * 2, codec.block_size)
end

"""
   TranscodingStreams.initialize(codec::LZ4SafeDecompressor)

Initializes the LZ4 Compression Codec.
"""
function TranscodingStreams.initialize(codec::LZ4SafeDecompressor)::Nothing
    codec.streamptr = LZ4_createStreamDecode()
    nothing
end

"""
    TranscodingStreams.finalize(codec::LZ4SafeDecompressor)

Finalizes the LZ4SafeDecompression Codec.
"""
function TranscodingStreams.finalize(codec::LZ4SafeDecompressor)::Nothing
    LZ4_freeStreamDecode(codec.streamptr)
    codec.streamptr = C_NULL
    nothing
end

"""
    TranscodingStreams.startproc(codec::LZ4SafeDecompressor, mode::Symbol, error::Error)

Starts processing with the codec
"""
function TranscodingStreams.startproc(
    codec::LZ4SafeDecompressor,
    mode::Symbol,
    error::Error
)::Symbol

    try
        LZ4_setStreamDecode(codec.streamptr)
        :ok
    catch err
        error[] = err
        :error
    end
end

"""
    TranscodingStreams.process(codec::LZ4SafeDecompressor, input::Memory, output::Memory, error::Error)

Compresses the data from `input` and writes to `output`.
The process follows the decompression example from
https://github.com/lz4/lz4/blob/dev/examples/blockStreaming_doubleBuffer.c
and requires each block of encoded data to be prefixed by the number of bytes contained in that block.
"""
function TranscodingStreams.process(
    codec::LZ4SafeDecompressor,
    input::Memory,
    output::Memory,
    error::Error
)::Tuple{Int,Int,Symbol}

    length(input) == 0 && return (0, 0, :end)
    try
        out_buffer = get_buffer!(codec.buffer)
        data_size = readint(input)

        decompressed_size = LZ4_decompress_safe_continue(
            codec.streamptr,
            input.ptr+CINT_SIZE,
            out_buffer,
            data_size,
            length(out_buffer)
        )

        checkbounds(output, decompressed_size)
        GC.@preserve out_buffer unsafe_copyto!(output.ptr, pointer(out_buffer), decompressed_size)

        return (data_size + CINT_SIZE, decompressed_size, :ok)
    catch err
        error[] = err
        return (0, 0, :error)
    end
end

# Julia wrapper for header: /usr/local/include/lz4frame.h
# Automatically generated using Clang.jl wrap_c, version 0.0.0
# docstrings copied from /usr/local/include/lz4frame.h

###########################
 # PRIVATE DEFINITIONS : Do Not Export
 # Do not use these definitions.
 # They are exposed to allow static allocation of `LZ4_streamHC_t`.
 # Using these definitions makes the code vulnerable to potential API break when upgrading LZ4
############################
const LZ4HC_DICTIONARY_LOGSIZE = 17
const LZ4HC_MAXD = 1 << LZ4HC_DICTIONARY_LOGSIZE
const LZ4HC_MAXD_MASK = LZ4HC_MAXD - 1
const LZ4HC_HASH_LOG = 15
const LZ4HC_HASHTABLESIZE = 1 << LZ4HC_HASH_LOG
const LZ4HC_HASH_MASK = LZ4HC_HASHTABLESIZE - 1
const LZ4_STREAMHCSIZE = 4LZ4HC_HASHTABLESIZE + 2LZ4HC_MAXD + 56
const LZ4_STREAMHCSIZE_SIZET = floor(Int, LZ4_STREAMHCSIZE / sizeof(Csize_t))

struct LZ4_streamHC_t
    table::NTuple{LZ4_STREAMHCSIZE_SIZET, Csize_t}
end

const LZ4_MEMORY_USAGE = 14
const LZ4_MAX_INPUT_SIZE = 0x7e000000

const LZ4_HASHLOG = LZ4_MEMORY_USAGE - 2
const LZ4_HASHTABLESIZE = 1 << LZ4_MEMORY_USAGE
const LZ4_HASH_SIZE_U32 = 1 << LZ4_HASHLOG

const LZ4_STREAMDECODESIZE_U64 = 4
const LZ4_STREAMSIZE_U64 =((1 << (LZ4_MEMORY_USAGE-3)) + 4)

struct LZ4_stream_t
    table::NTuple{LZ4_STREAMSIZE_U64, Culonglong}
end

struct LZ4_streamDecode_t
    table::NTuple{LZ4_STREAMDECODESIZE_U64, Culonglong}
end

# Constants
const LZ4F_VERSION = 100
const LZ4F_HEADER_SIZE_MAX = 19

# Block Size
const LZ4F_default = (UInt32)(0)
const LZ4F_max64KB = (UInt32)(4)
const LZ4F_max256KB = (UInt32)(5)
const LZ4F_max1MB = (UInt32)(6)
const LZ4F_max4MB = (UInt32)(7)

# Block Mode
const LZ4F_blockLinked = (UInt32)(0)
const LZ4F_blockIndependent = (UInt32)(1)

# Content Checksum Flag
const LZ4F_noContentChecksum = (UInt32)(0)
const LZ4F_contentChecksumEnabled = (UInt32)(1)

# Block Checksum Flag
const LZ4F_noBlockChecksum = (UInt32)(0)
const LZ4F_blockChecksumEnabled = (UInt32)(1)

# Frame Type
const LZ4F_frame = (UInt32)(0)
const LZ4F_skippableFrame = (UInt32)(1)

@enum BlockSizeID::Cuint default_size = 0 max64KB = 4 max256KB = 5 max1MB = 6 max4MB = 7
@enum BlockMode::Cuint block_linked = 0 block_independent = 1
@enum FrameType::Cuint normal_frame = 0 skippable_frame = 1

struct LZ4F_compressOptions_t
    stableSrc::Cuint
    reserved::NTuple{3, Cuint}
end

struct LZ4F_decompressOptions_t
    stableDst::Cuint
    reserved::NTuple{3, Cuint}
end

struct LZ4F_frameInfo_t
    blockSizeID::Cuint
    blockMode::Cuint
    contentChecksumFlag::Cuint
    frameType::Cuint
    contentSize::Culonglong
    dictID::Cuint
    blockChecksumFlag::Cuint
end

function LZ4F_frameInfo_t(;
    blocksizeid::BlockSizeID=default_size,
    blockmode::BlockMode=block_linked,
    contentchecksum::Bool=false,
    frametype::FrameType=normal_frame,
    contentsize::Integer=0,
    blockchecksum::Bool=false,
)
    LZ4F_frameInfo_t(Cuint(blocksizeid), Cuint(blockmode), Cuint(contentchecksum), Cuint(frametype), Culonglong(contentsize), Cuint(0), Cuint(blockchecksum))
end

struct LZ4F_preferences_t
    frameInfo::LZ4F_frameInfo_t
    compressionLevel::Cint
    autoFlush::Cuint
    reserved::NTuple{4, Cuint}
end

function LZ4F_preferences_t(frame_info::LZ4F_frameInfo_t; compressionlevel::Integer=0, autoflush::Bool=false)
    LZ4F_preferences_t(frame_info, Cint(compressionlevel), Cuint(autoflush), (0,0,0,0))
end

struct LZ4F_CDict
    dictContent::Ptr{Cvoid}
    fastCtx::Ptr{LZ4_stream_t}
    HCCtx::Ptr{LZ4_streamHC_t}
end

struct XXH32_state_t
   total_len_32::Cuint
   large_len::Cuint
   v1::Cuint
   v2::Cuint
   v3::Cuint
   v4::Cuint
   mem32::NTuple{4,UInt32}
   memsize::Cuint
   reserved::Cuint
end

struct LZ4F_cctx
    prefs::LZ4F_preferences_t
    version::UInt32
    cStage::UInt32
    cdict::Ptr{LZ4F_CDict}
    maxBlockSize::Csize_t
    maxBufferSize::Csize_t
    tmpBuff::Ptr{Cuchar}
    tmpIn::Ptr{Cuchar}
    tmpInSize::Csize_t
    totalInSize::UInt64
    xxh::XXH32_state_t
    lz4CtxPtr::Ptr{Cvoid}
    lz4CtxLevel::UInt32
end

struct LZ4F_dctx
    frameInfo::LZ4F_frameInfo_t
    version::UInt32
    dStage::UInt32
    frameRemainingSize::UInt64
    maxBlockSize::Csize_t
    maxBufferSize::Csize_t
    tmpIn::Ptr{Cuchar}
    tmpInSize::Csize_t
    tmpInTarget::Csize_t
    tmpOutBuffer::Ptr{Cuchar}
    dict::Ptr{Cuchar}
    dictSize::Csize_t
    tmpOut::Ptr{Cuchar}
    tmpOutSize::Csize_t
    tmpOutStart::Csize_t
    xxh::XXH32_state_t
    blockChecksum::XXH32_state_t
    header::NTuple{LZ4F_HEADER_SIZE_MAX, Cuchar}
end

function check_context_initialized(ctx::Ptr{LZ4F_cctx})
    if ctx == Ptr{LZ4F_cctx}(C_NULL)
        throw(LZ4Exception("LZ4F_cctx", "Uninitialized compression context"))
    end
end

function check_context_initialized(ctx::Ptr{LZ4F_dctx})
    if ctx == Ptr{LZ4F_dctx}(C_NULL)
        throw(LZ4Exception("LZ4F_dctx", "Uninitialized decompression context"))
    end
end

function LZ4F_isError(code::Csize_t)
    err = ccall((:LZ4F_isError, liblz4), UInt32, (Csize_t,), code)
    convert(Bool, err)
end

function LZ4F_getErrorName(code::Csize_t)
    str = ccall((:LZ4F_getErrorName, liblz4), Cstring, (Csize_t,), code)
    unsafe_string(str)
end

"""
Gets the current LZ4F version.
"""
function LZ4F_getVersion()
    ccall((:LZ4F_getVersion, liblz4), UInt32, ())
end

"""
The first thing to do is to create a compressionContext object, which will be used in all compression operations.
This is achieved using `LZ4F_createCompressionContext()`, which takes as argument a version.
The version provided MUST be the current version. It is intended to track potential version mismatch, notably when using DLL.
The function will provide a pointer to a fully allocated `LZ4F_cctx` object.
Will throw an error if there was an error during context creation.
"""
function LZ4F_createCompressionContext(cctxPtr::Ref{Ptr{LZ4F_cctx}}, version::UInt32)
    ret = ccall((:LZ4F_createCompressionContext, liblz4), Csize_t, (Ref{Ptr{LZ4F_cctx}}, UInt32), cctxPtr, version)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_createCompressionContext", LZ4F_getErrorName(ret)))
    end
    ret
end

"""
Releases the memory of a `LZ4F_cctx`.
"""
function LZ4F_freeCompressionContext(cctx::Ptr{LZ4F_cctx})
    ccall((:LZ4F_freeCompressionContext, liblz4), Csize_t, (Ptr{LZ4F_cctx},), cctx)
end

"""
Will write the frame header into `dstBuffer`.

`dstCapacity` must be >= `LZ4F_HEADER_SIZE_MAX` bytes.
`prefsPtr` is optional : you can provide `C_NULL` as argument, all preferences will then be set to default.
Returns the number of bytes written into `dstBuffer` for the header or throws an error.
 """
function LZ4F_compressBegin(cctx::Ptr{LZ4F_cctx}, dstBuffer, dstCapacity::Csize_t, prefsPtr::Ref{LZ4F_preferences_t})
    check_context_initialized(cctx)
    ret = ccall((:LZ4F_compressBegin, liblz4), Csize_t, (Ptr{LZ4F_cctx}, Ptr{Cvoid}, Csize_t, Ref{LZ4F_preferences_t}), cctx, dstBuffer, dstCapacity, prefsPtr)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_compressBegin" ,LZ4F_getErrorName(ret)))
    end
    ret
end

"""
Provides minimum `dstCapacity` for a given `srcSize` to guarantee operation success in worst case situations.

`prefsPtr` is optional : when `C_NULL` is provided, preferences will be set to cover worst case scenario.
Result is always the same for a `srcSize` and `prefsPtr`, so it can be trusted to size reusable buffers.
When `srcSize==0`, `LZ4F_compressBound()` provides an upper bound for `LZ4F_flush()` and `LZ4F_compressEnd()` operations.
"""
function LZ4F_compressBound(srcSize::Csize_t, prefsPtr::Ref{LZ4F_preferences_t})
    ccall((:LZ4F_compressBound, liblz4), Csize_t, (Csize_t, Ref{LZ4F_preferences_t}), srcSize, prefsPtr)
end

"""
Can be called repetitively to compress as much data as necessary.

An important rule is that `dstCapacity` MUST be large enough to ensure operation success even in worst case situations.
This value is provided by `LZ4F_compressBound()`.
If this condition is not respected, `LZ4F_compress()` will fail.
LZ4F_compressUpdate() doesn't guarantee error recovery. When an error occurs, compression context must be freed or resized.
`cOptPtr` is optional : `C_NULL` can be provided, in which case all options are set to default.
Returns the number of bytes written into `dstBuffer` (it can be zero, meaning input data was just buffered).
or throws an error if it fails.
 """
function LZ4F_compressUpdate(cctx::Ptr{LZ4F_cctx}, dstBuffer, dstCapacity::Csize_t, srcBuffer, srcSize::Csize_t, cOptPtr)
    check_context_initialized(cctx)
    ret = ccall((:LZ4F_compressUpdate, liblz4), Csize_t, (Ptr{LZ4F_cctx}, Ptr{Cvoid}, Csize_t, Ptr{Cvoid}, Csize_t, Ptr{LZ4F_compressOptions_t}), cctx, dstBuffer, dstCapacity, srcBuffer, srcSize, cOptPtr)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_compressUpdate", LZ4F_getErrorName(ret)))
    end
    ret
end

"""
When data must be generated and sent immediately, without waiting for a block to be completely filled,
it's possible to call `LZ4_flush()`. It will immediately compress any data buffered within `cctx`.
`dstCapacity` must be large enough to ensure the operation will be successful.
`cOptPtr` is optional : it's possible to provide `C_NULL`, all options will be set to default.
Returns the number of bytes written into `dstBuffer` (it can be zero, which means there was no data stored within `cctx`)
or throws an error if it fails.
"""
function LZ4F_flush(cctx::Ptr{LZ4F_cctx}, dstBuffer, dstCapacity::Csize_t, cOptPtr)
    check_context_initialized(cctx)
    ret = ccall((:LZ4F_flush, liblz4), Csize_t, (Ptr{LZ4F_cctx}, Ptr{Cvoid}, Csize_t, Ptr{LZ4F_compressOptions_t}), cctx, dstBuffer, dstCapacity, cOptPtr)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_flush", LZ4F_getErrorName(ret)))
    end
    ret
end

"""
Invoke to properly finish an LZ4 frame.

It will flush whatever data remained within `cctx` (like `LZ4_flush()`)
and properly finalize the frame, with an endMark and a checksum.
`cOptPtr` is optional : `C_NULL` can be provided, in which case all options will be set to default.
Returns the number of bytes written into `dstBuffer` (necessarily >= 4 (endMark), or 8 if optional frame checksum is enabled)
or throws an error if it fails (which can be tested using `LZ4F_isError()`)
A successful call to `LZ4F_compressEnd()` makes `cctx` available again for another compression task.
"""
function LZ4F_compressEnd(cctx::Ptr{LZ4F_cctx}, dstBuffer, dstCapacity::Csize_t, cOptPtr)
    check_context_initialized(cctx)
    ret = ccall((:LZ4F_compressEnd, liblz4), Csize_t, (Ptr{LZ4F_cctx}, Ptr{Cvoid}, Csize_t, Ptr{LZ4F_compressOptions_t}), cctx, dstBuffer, dstCapacity, cOptPtr)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_compressEnd", LZ4F_getErrorName(ret)))
    end
    ret
end

"""
Create an `LZ4F_dctx object`, to track all decompression operations.

The version provided MUST be the current LZ4F version.
The function provides a pointer to an allocated and initialized `LZ4F_dctx` object.
The the function throws an error if the `LZ4F_dctx` object cannot be initialized.
The `dctx` memory can be released using `LZ4F_freeDecompressionContext()`.
"""
function LZ4F_createDecompressionContext(dctxPtr::Ref{Ptr{LZ4F_dctx}}, version::UInt32)
    ret = ccall((:LZ4F_createDecompressionContext, liblz4), Csize_t, (Ref{Ptr{LZ4F_dctx}}, UInt32), dctxPtr, version)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_createDecompressionContext", LZ4F_getErrorName(ret)))
    end
    ret
end

"""
Frees the decompressionContext.

The result of `LZ4F_freeDecompressionContext()` is indicative of the current state of decompressionContext when being released.
That is, it should be == 0 if decompression has been completed fully and correctly.
"""
function LZ4F_freeDecompressionContext(dctx::Ptr{LZ4F_dctx})
    ccall((:LZ4F_freeDecompressionContext, liblz4), Csize_t, (Ptr{LZ4F_dctx},), dctx)
end

"""
Extracts frame parameters (max blockSize, dictID, etc.).

Its usage is optional.
Extracted information is typically useful for allocation and dictionary.
This function works in 2 situations :
 - At the beginning of a new frame, in which case
   it will decode information from `srcBuffer`, starting the decoding process.
   Input size must be large enough to successfully decode the entire frame header.
   Frame header size is variable, but is guaranteed to be <= `LZ4F_HEADER_SIZE_MAX` bytes.
   It's allowed to provide more input data than this minimum.
 - After decoding has been started.
   In which case, no input is read, frame parameters are extracted from dctx.
 - If decoding has barely started, but not yet extracted information from header,
   `LZ4F_getFrameInfo()` will fail.
The number of bytes consumed from srcBuffer will be updated within `srcSizePtr` (necessarily <= original value).
Decompression must resume from (`srcBuffer` + `srcSizePtr`).
Returns an hint about how many `srcSize` bytes `LZ4F_decompress()` expects for next call or throws an error.

Note 1 : In case of error, dctx is not modified. Decoding operation can resume from beginning safely.
Note 2 : Frame parameters are *copied into* an already allocated `LZ4F_frameInfo_t` structure.
"""
function LZ4F_getFrameInfo(dctx::Ptr{LZ4F_dctx}, frameInfoPtr::Ref{LZ4F_frameInfo_t}, srcBuffer, srcSizePtr)
    check_context_initialized(dctx)
    ret = ccall((:LZ4F_getFrameInfo, liblz4), Csize_t, (Ptr{LZ4F_dctx}, Ref{LZ4F_frameInfo_t}, Ptr{Cvoid}, Ref{Csize_t}), dctx, frameInfoPtr, srcBuffer, srcSizePtr)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_getFrameInfo", LZ4F_getErrorName(ret)))
    end
    ret
end

"""
Call this function repetitively to regenerate compressed data from `srcBuffer`.

The function will read up to `srcSizePtr` bytes from `srcBuffer`,
and decompress data into `dstBuffer`, of capacity `dstSizePtr`.
The number of bytes consumed from `srcBuffer` will be written into `srcSizePtr` (necessarily <= original value).
The number of bytes decompressed into `dstBuffer` will be written into `dstSizePtr` (necessarily <= original value).
The function does not necessarily read all input bytes, so always check value in `srcSizePtr`.
Unconsumed source data must be presented again in subsequent invocations.

`dstBuffer` can freely change between each consecutive function invocation.
`dstBuffer` content will be overwritten.

Returns an hint of how many `srcSize` bytes `LZ4F_decompress()` expects for next call.
Schematically, it's the size of the current (or remaining) compressed block + header of next block.
Respecting the hint provides some small speed benefit, because it skips intermediate buffers.
This is just a hint though, it's always possible to provide any srcSize.

When a frame is fully decoded, returns 0 (no more data expected).
When provided with more bytes than necessary to decode a frame,
`LZ4F_decompress()` will stop reading exactly at end of current frame, and return 0.

If decompression failed, an error is thrown.
After a decompression error, the `dctx` context is not resumable.
Use `LZ4F_resetDecompressionContext()` to return to clean state.
After a frame is fully decoded, dctx can be used again to decompress another frame.
"""
function LZ4F_decompress(dctx::Ptr{LZ4F_dctx}, dstBuffer, dstSizePtr::Ref{Csize_t}, srcBuffer, srcSizePtr::Ref{Csize_t}, dOptPtr)
    check_context_initialized(dctx)
    ret = ccall((:LZ4F_decompress, liblz4), Csize_t, (Ptr{LZ4F_dctx}, Ptr{Cvoid}, Ref{Csize_t}, Ptr{Cvoid}, Ref{Csize_t}, Ptr{LZ4F_decompressOptions_t}), dctx, dstBuffer, dstSizePtr, srcBuffer, srcSizePtr, dOptPtr)
    if LZ4F_isError(ret)
        throw(LZ4Exception("LZ4F_decompress", LZ4F_getErrorName(ret)))
    end
    ret
end


"""
Re-initializes decompression context

In case of an error, the context is left in "undefined" state.
In which case, it's necessary to reset it, before re-using it.
This method can also be used to abruptly stop any unfinished decompression,
and start a new one using same context resources.
 """
function LZ4F_resetDecompressionContext(dctx::Ptr{LZ4F_dctx})
    check_context_initialized(dctx)
    ccall((:LZ4F_resetDecompressionContext, liblz4), Cvoid, (Ptr{LZ4F_dctx},), dctx)
end

## version of ccall that calls jl_gc_safe_enter|leave around the inner ccall
# note that this is generally only safe with functions that do not call back into
# Julia

const HAS_CCALL_GCSAFE = VERSION >= v"1.13.0-DEV.70" || v"1.12-DEV.2029" <= VERSION < v"1.13-"

"""
    @gcsafe_ccall ...

Call a foreign function just like [`@ccall`](https://docs.julialang.org/en/v1/base/c/#Base.@ccall),
but marking it safe for the GC to run. This is useful for functions that may block, so that the GC
isn't blocked from running, but may also be required to prevent deadlocks (see JuliaGPU/CUDA.jl#2261).

Note that this is generally only safe with non-Julia C functions that do not call back into Julia
directly.
"""
macro gcsafe_ccall end

if HAS_CCALL_GCSAFE
    macro gcsafe_ccall(expr)
        exprs = Any[:(gc_safe = true), expr]
        return Base.ccall_macro_lower((:ccall), Base.ccall_macro_parse(exprs)...)
    end
else
    function ccall_macro_lower(func, rettype, types, args, nreq)
        # instead of re-using ccall or Expr(:foreigncall) to perform argument conversion,
        # we need to do so ourselves in order to insert a jl_gc_safe_enter|leave
        # just around the inner ccall

        cconvert_exprs = []
        cconvert_args = []
        for (typ, arg) in zip(types, args)
            var = gensym("$(func)_cconvert")
            push!(cconvert_args, var)
            push!(cconvert_exprs, :($var = Base.cconvert($(esc(typ)), $(esc(arg)))))
        end

        unsafe_convert_exprs = []
        unsafe_convert_args = []
        for (typ, arg) in zip(types, cconvert_args)
            var = gensym("$(func)_unsafe_convert")
            push!(unsafe_convert_args, var)
            push!(unsafe_convert_exprs, :($var = Base.unsafe_convert($(esc(typ)), $arg)))
        end

        call = quote
            $(unsafe_convert_exprs...)

            gc_state = @ccall(jl_gc_safe_enter()::Int8)
            ret = ccall(
                $(esc(func)), $(esc(rettype)), $(Expr(:tuple, map(esc, types)...)),
                $(unsafe_convert_args...)
            )
            @ccall(jl_gc_safe_leave(gc_state::Int8)::Cvoid)
            ret
        end

        return quote
            @static if VERSION >= v"1.8"
                @inline
            end
            $(cconvert_exprs...)
            GC.@preserve $(cconvert_args...) $(call)
        end
    end

    macro gcsafe_ccall(expr)
        return ccall_macro_lower(Base.ccall_macro_parse(expr)...)
    end
end # HAS_CCALL_GCSAFE

using CodecLz4
using InteractiveUtils

@testset "gcsafe_ccall" begin
    function gc_safe_ccall()
        # jl_symbol is marked as JL_NOTSAFEPOINT
        CodecLz4.@gcsafe_ccall jl_symbol("gc_safe_ccall"::Cstring)::Symbol
    end

    let llvm = sprint(code_llvm, gc_safe_ccall, ())
        # check that the call works
        @test gc_safe_ccall() isa Symbol
        # v1.10 is hard to test since ccall are just raw runtime pointers
        if VERSION >= v"1.11"
            if !CodecLz4.HAS_CCALL_GCSAFE
                # check for the gc_safe store
                @test occursin("jl_gc_safe_enter", llvm)
                @test occursin("jl_gc_safe_leave", llvm)
            else
                @test occursin("store atomic i8 2", llvm)
            end
        end
    end
end

# Julia wrapper for header: /usr/local/include/lz4hc.h
# docstrings copied from /usr/local/include/lz4hc.h

const LZ4HC_CLEVEL_MIN = 3
const LZ4HC_CLEVEL_DEFAULT = 9
const LZ4HC_CLEVEL_OPT_MIN = 11
const LZ4HC_CLEVEL_MAX = 12

function check_initialized(stream::Ptr{LZ4_streamHC_t})
    if stream == Ptr{LZ4_streamHC_t}(C_NULL)
        throw(LZ4Exception("LZ4_streamHC_t", "Uninitialized compression stream"))
    end
end

"""
    LZ4_compress_HC(src, dst, srcsize, dstcapacity, compressionlevel)

Compress data from `src` into `dst`, using the more powerful but slower "HC" algorithm.
`dst` must be already allocated.
Compression is guaranteed to succeed if `dstcapacity >= LZ4_compressBound(srcsize)`
Max supported `srcsize` value is LZ4_MAX_INPUT_SIZE
`compressionlevel`: any value between 1 and LZ4HC_CLEVEL_MAX will work.
                    Values > LZ4HC_CLEVEL_MAX behave the same as LZ4HC_CLEVEL_MAX.
Returns the number of bytes written into `dst`
"""
function LZ4_compress_HC(src, dst, srcsize, dstcapacity, compressionlevel=LZ4HC_CLEVEL_DEFAULT)
    ret = ccall((:LZ4_compress_HC, liblz4), Cint, (Cstring, Cstring, Cint, Cint, Cint), src, dst, srcsize, dstcapacity, compressionlevel)
    check_compression_error(ret, "LZ4_compress_HC")
end

"""
    LZ4_createStreamHC()

Create memory for LZ4 HC streaming state.
Newly created states are automatically initialized.
Existing states can be re-used several times, using LZ4_resetStreamHC().
"""
function LZ4_createStreamHC()
    str = ccall((:LZ4_createStreamHC, liblz4), Ptr{LZ4_streamHC_t}, ())
    if str == C_NULL # Could not allocate memory
        throw(OutOfMemoryError())
    end
    return str
end

"""
    LZ4_freeStreamHC(streamptr)

Release memory for LZ4 HC streaming state.
Existing states can be re-used several times, using LZ4_resetStreamHC().
"""
function LZ4_freeStreamHC(streamptr::Ptr{LZ4_streamHC_t})
    ccall((:LZ4_freeStreamHC, liblz4), Cint, (Ptr{LZ4_streamHC_t},), streamptr)
end

function LZ4_resetStreamHC(streamptr::Ptr{LZ4_streamHC_t}, compressionlevel=LZ4HC_CLEVEL_DEFAULT)
    check_initialized(streamptr)
    ccall((:LZ4_resetStreamHC, liblz4), Cvoid, (Ptr{LZ4_streamHC_t}, Cint), streamptr, compressionlevel)
end

"""
    LZ4_compress_HC_continue(streamptr::Ptr{LZ4_streamHC_t}, src, dst, srcsize, maxdstsize)

Compress data in successive blocks of any size, using previous blocks as dictionary.
One key assumption is that previous blocks (up to 64 KB) remain read-accessible while compressing next blocks.
There is an exception for ring buffers, which can be smaller than 64 KB.
Ring buffers scenario is automatically detected and handled by LZ4_compress_HC_continue().

Before starting compression, state must be properly initialized, using LZ4_resetStreamHC().

Then, use LZ4_compress_HC_continue() to compress each successive block.
Previous memory blocks (including initial dictionary when present) must remain accessible and unmodified during compression.
`dst` buffer should be sized to handle worst case scenarios (see LZ4_compressBound()), to ensure operation success.
Because in case of failure, the API does not guarantee context recovery, and context will have to be reset.
"""
function LZ4_compress_HC_continue(streamptr::Ptr{LZ4_streamHC_t}, src, dst, srcsize, maxdstsize)
    check_initialized(streamptr)
    ret = ccall((:LZ4_compress_HC_extStateHC, liblz4), Cint, (Ptr{LZ4_streamHC_t}, Cstring, Cstring, Cint, Cint), streamptr, src, dst, srcsize, maxdstsize)
    check_compression_error(ret, "LZ4_compress_HC_continue")
end

# function LZ4_loadDictHC(streamHCPtr, dictionary, dictSize)
#     ccall((:LZ4_loadDictHC, liblz4), Cint, (Ptr{LZ4_streamHC_t}, Cstring, Cint), streamHCPtr, dictionary, dictSize)
# end

# function LZ4_saveDictHC(streamHCPtr, safeBuffer, maxDictSize)
#     ccall((:LZ4_saveDictHC, liblz4), Cint, (Ptr{LZ4_streamHC_t}, Cstring, Cint), streamHCPtr, safeBuffer, maxDictSize)
# end

@testset "lz4hc" begin
    test_in = """
        Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
        incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud
        exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
        """
    test_size = convert(Cint, length(test_in))
    bound = CodecLz4.LZ4_compressBound(test_size)
    bufsize = bound
    half_bufsize = floor(Cint, bufsize/2)
    buffer = Vector{UInt8}(undef, bufsize)
    dec_buffer = Vector{UInt8}(undef, test_size)

    @testset "compress" begin
        result = CodecLz4.LZ4_compress_HC(pointer(test_in), pointer(buffer), test_size, bufsize, 13)

        result = CodecLz4.LZ4_decompress_safe(pointer(buffer), pointer(dec_buffer), result, test_size)
        @test unsafe_string(pointer(dec_buffer), test_size) == test_in

        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4_compress_HC(pointer(test_in), pointer(buffer), test_size, half_bufsize, 12)
    end

    @testset "streams" begin
        comp_str = CodecLz4.LZ4_createStreamHC()
        try
            @test CodecLz4.LZ4_resetStreamHC(comp_str, 1) === nothing

            result = CodecLz4.LZ4_compress_HC_continue(comp_str, pointer(test_in), pointer(buffer), test_size, bufsize)
            @test result > 0
            result = CodecLz4.LZ4_decompress_safe(pointer(buffer), pointer(dec_buffer), result, test_size)

            @test result == test_size
            @test unsafe_string(pointer(dec_buffer), result) == test_in
        finally
            @test CodecLz4.LZ4_freeStreamHC(comp_str) == 0
        end
    end

    @testset "errors" begin
        stream = Ref{Ptr{CodecLz4.LZ4_streamHC_t}}(C_NULL)

        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4_resetStreamHC(stream[])
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4_compress_HC_continue(stream[], pointer(test_in), pointer(buffer), test_size, bufsize)
        @test CodecLz4.LZ4_freeStreamHC(stream[]) == 0
    end
end

# Julia wrapper for header: /usr/local/include/lz4.h
# docstrings copied from /usr/local/include/lz4.h

function check_compression_error(ret::Integer, function_name::AbstractString)
    ret == 0 && throw(LZ4Exception(function_name, "Compression failed."))
    return ret
end

function check_decompression_error(ret::Integer, function_name::AbstractString)
    ret < 0 && throw(LZ4Exception(function_name, "Decompression failed."))
    return ret
end

function check_initialized(stream::Ptr{LZ4_stream_t})
    if stream == Ptr{LZ4_stream_t}(C_NULL)
        throw(LZ4Exception("LZ4_stream_t", "Uninitialized compression stream"))
    end
end

function check_initialized(stream::Ptr{LZ4_streamDecode_t})
    if stream == Ptr{LZ4_streamDecode_t}(C_NULL)
        throw(LZ4Exception("LZ4_streamDecode_t", "Uninitialized decompression stream"))
    end
end

"""
    LZ4_compress_fast(src, dst, srcsize, dstcapacity=1)

Compresses `srcsize` bytes from buffer `src`
into already allocated `dst` buffer of size `dstcapacity`.
Compression is guaranteed to succeed if `dstcapacity` >= LZ4_compressBound(srcsize).
It also runs faster, so it's a recommended setting.
If the function cannot compress `src` into a limited `dst` budget,
compression stops *immediately*, and the function result is zero.
As a consequence, `dst` content is not valid.

Also allows to select an `acceleration` factor.
The larger the acceleration value, the faster the algorithm, but also the lesser the compression.
It's a trade-off. It can be fine tuned, with each successive value providing roughly +~3% to speed.
Values <= 0 will be replaced by the default which is 1.

This function never writes outside `dst` buffer, nor read outside `source` buffer.
    srcsize : supported max value is LZ4_MAX_INPUT_VALUE
    dstcapacity : full or partial size of buffer `dst` (which must be already allocated)

Returns the number of bytes written into buffer `dst` (necessarily <= dstcapacity)
"""
function LZ4_compress_fast(src, dst, srcsize, dstcapacity, acceleration=1)
    ret = @gcsafe_ccall liblz4.LZ4_compress_fast(src::Ptr{UInt8}, dst::Ptr{UInt8}, srcsize::Cint, dstcapacity::Cint, acceleration::Cint)::Cint
    check_compression_error(ret, "LZ4_compress_fast")
end

"""
    LZ4_compress_destSize(src, dst, srcsize, dstcapacity)

Reverse the logic : compresses as much data as possible from `src` buffer
into already allocated buffer `dst` of size `dstcapacity`.
This function either compresses the entire `src` content into `dst` if it's large enough,
or fill `dst` buffer completely with as much data as possible from `src`.
    *srcsize : will be modified to indicate how many bytes where read from `src` to fill `dst`.
                  New value is necessarily <= old value.

Returns number of bytes written into `dst` (necessarily <= dstcapacity)
"""
function LZ4_compress_destSize(src, dst, srcsize, dstcapacity)
    ret = @gcsafe_ccall liblz4.LZ4_compress_destSize(src::Ptr{UInt8}, dst::Ptr{UInt8}, srcsize::Ptr{Cint}, dstcapacity::Cint)::Cint
    check_compression_error(ret, "LZ4_compress_destSize")
end

"""
    LZ4_compressBound(inputsize)

Provides the maximum size that LZ4 compression may output in a "worst case" scenario (input data not compressible)
This function is primarily useful for memory allocation purposes (destination buffer size).
Macro LZ4_COMPRESSBOUND() is also provided for compilation-time evaluation (stack memory allocation for example).
Note that LZ4_compress_default() compress faster when dest buffer size is >= LZ4_compressBound(srcsize)
    inputsize  : max supported value is LZ4_MAX_INPUT_SIZE

Returns maximum output size in a "worst case" scenario or 0, if input size is too large ( > LZ4_MAX_INPUT_SIZE)
"""
function LZ4_compressBound(inputsize)
    ccall((:LZ4_compressBound, liblz4), Cint, (Cint,), inputsize)
end

"""
    LZ4_createStream()

Will allocate and initialize an `LZ4_stream_t` structure.
"""
function LZ4_createStream()
    str = ccall((:LZ4_createStream, liblz4), Ptr{LZ4_stream_t}, ())
    if str == C_NULL # Could not allocate memory
        throw(OutOfMemoryError())
    end
    return str
end

"""
    LZ4_freeStream(streamptr::Ptr{LZ4_stream_t})

Releases memory allocated by LZ4_createStream.
"""
function LZ4_freeStream(streamptr::Ptr{LZ4_stream_t})
    ccall((:LZ4_freeStream, liblz4), Cint, (Ptr{LZ4_stream_t},), streamptr)
end

"""
    LZ4_resetStream(streamptr)

An LZ4_stream_t structure can be allocated once and re-used multiple times.
Use this function to start compressing a new stream.
"""
function LZ4_resetStream(streamptr::Ptr{LZ4_stream_t})
    check_initialized(streamptr)
    ccall((:LZ4_resetStream, liblz4), Cvoid, (Ptr{LZ4_stream_t},), streamptr)
end

"""
    LZ4_compress_fast_continue(streamptr, src, dst, srcsize, dstcapacity, acceleration)

Compress content into `src` using data from previously compressed blocks, improving compression ratio.
`dst` buffer must be already allocated.
If dstcapacity >= LZ4_compressBound(srcsize), compression is guaranteed to succeed, and runs faster.

Important : Up to 64KB of previously compressed data is assumed to remain present and unmodified in memory !
Special 1 : If input buffer is a double-buffer, it can have any size, including < 64 KB.
Special 2 : If input buffer is a ring-buffer, it can have any size, including < 64 KB.

Returns size of compressed block.
After an error, the stream status is invalid, it can only be reset or freed.
"""
function LZ4_compress_fast_continue(streamptr::Ptr{LZ4_stream_t}, src, dst, srcsize, dstcapacity, acceleration=1)
    check_initialized(streamptr)
    ret = ccall((:LZ4_compress_fast_continue, liblz4), Cint, (Ptr{LZ4_stream_t}, Ptr{UInt8}, Ptr{UInt8}, Cint, Cint, Cint), streamptr, src, dst, srcsize, dstcapacity, acceleration)
    check_compression_error(ret, "LZ4_compress_fast_continue")
end

"""
    LZ4_decompress_safe(src, dst, cmpsize, dstcapacity)

Decompresses `cmpsize` bytes from buffer `src` into `dst`.
If destination buffer is not large enough, decoding will stop and output an error.
If the source stream is detected malformed, the function will stop decoding and error.
This function is protected against buffer overflow exploits, including malicious data packets.
It never writes outside output buffer, nor reads outside input buffer.

cmpsize : is the exact complete size of the compressed block.
dstcapacity : is the size of destination buffer, which must be already allocated.

Returns the number of bytes decompressed into destination buffer (necessarily <= dstcapacity)
"""
function LZ4_decompress_safe(src, dst, cmpsize, dstcapacity)
    ret = @gcsafe_ccall liblz4.LZ4_decompress_safe(src::Ptr{UInt8}, dst::Ptr{UInt8}, cmpsize::Cint, dstcapacity::Cint)::Cint
    check_decompression_error(ret, "LZ4_decompress_safe")
end

"""
    LZ4_createStreamDecode()

These decoding functions work the same as
creation / destruction of streaming decompression tracking structure.
A tracking structure can be re-used multiple times sequentially.
"""
function LZ4_createStreamDecode()
    str = ccall((:LZ4_createStreamDecode, liblz4), Ptr{LZ4_streamDecode_t}, ())
    if str == C_NULL # Could not allocate memory
        throw(OutOfMemoryError())
    end
    return str
end

"""
    LZ4_freeStreamDecode(streamptr)

These decoding functions work the same as
creation / destruction of streaming decompression tracking structure.
A tracking structure can be re-used multiple times sequentially.
"""
function LZ4_freeStreamDecode(streamptr::Ptr{LZ4_streamDecode_t})
    ccall((:LZ4_freeStreamDecode, liblz4), Cint, (Ptr{LZ4_streamDecode_t},), streamptr)
end

"""
    LZ4_setStreamDecode(streamptr, dictionary, dictsize)

An LZ4_streamDecode_t structure can be allocated once and re-used multiple times.
Use this function to start decompression of a new stream of blocks.
A dictionary can optionally be set. Use NULL or size 0 for a simple reset order.
Returns 1 if OK
"""
function LZ4_setStreamDecode(streamptr::Ptr{LZ4_streamDecode_t}, dictionary=C_NULL, dictsize=0)
    check_initialized(streamptr)
    ret = ccall((:LZ4_setStreamDecode, liblz4), Cint, (Ptr{LZ4_streamDecode_t}, Ptr{UInt8}, Cint), streamptr, dictionary, dictsize)
    ret == 0 && throw(LZ4Exception("LZ4_setStreamDecode", "Stream reinitialization failed."))
    return ret
end

"""
    LZ4_decompress_safe_continue(streamptr, src, dst, srcsize, dstcapacity)

These decoding functions allow decompression of consecutive blocks in "streaming" mode.
A block is an unsplittable entity, it must be presented entirely to a decompression function.
Decompression functions only accept one block at a time.
Previously decoded blocks *must* remain available at the memory position where they were decoded (up to 64 KB).

Special : if application sets a ring buffer for decompression, it must respect one of the following conditions :
- Exactly same size as encoding buffer, with same update rule (block boundaries at same positions)
  In which case, the decoding & encoding ring buffer can have any size, including very small ones ( < 64 KB).
- Larger than encoding buffer, by a minimum of maxBlockSize more bytes.
  maxBlockSize is implementation dependent. It's the maximum size of any single block.
  In which case, encoding and decoding buffers do not need to be synchronized,
  and encoding ring buffer can have any size, including small ones ( < 64 KB).
- _At least_ 64 KB + 8 bytes + maxBlockSize.
  In which case, encoding and decoding buffers do not need to be synchronized,
  and encoding ring buffer can have any size, including larger than decoding buffer.
Whenever these conditions are not possible, save the last 64KB of decoded data into a safe buffer,
and indicate where it is saved using `LZ4_setStreamDecode()` before decompressing next block.
"""
function LZ4_decompress_safe_continue(streamptr::Ptr{LZ4_streamDecode_t}, src, dst, srcsize, dstcapacity)
    check_initialized(streamptr)
    ret = ccall((:LZ4_decompress_safe_continue, liblz4), Cint, (Ptr{LZ4_streamDecode_t}, Ptr{UInt8}, Ptr{UInt8}, Cint, Cint), streamptr, src, dst, srcsize, dstcapacity)
    check_decompression_error(ret, "LZ4_decompress_safe_continue")
end

@testset "lz4frame" begin
     test_in = "Far out in the uncharted backwaters of the unfashionable end of the west-
 ern  spiral  arm  of  the  Galaxy  lies  a  small  unregarded  yellow  sun."
    test_size = convert(UInt, length(test_in))
    version = CodecLz4.LZ4F_getVersion()

    @testset "Errors" begin
        no_error = UInt(0)
        @test !CodecLz4.LZ4F_isError(no_error)
        @test CodecLz4.LZ4F_getErrorName(no_error) == "Unspecified error code"

        ERROR_GENERIC = typemax(UInt)
        @test CodecLz4.LZ4F_isError(ERROR_GENERIC)
        @test CodecLz4.LZ4F_getErrorName(ERROR_GENERIC) == "ERROR_GENERIC"
    end

    @testset "keywords" begin
        frame = CodecLz4.LZ4F_frameInfo_t()
        @test frame.blockSizeID == Cuint(default_size)
        @test frame.blockMode == Cuint(block_linked)
        @test frame.contentChecksumFlag == Cuint(0)
        @test frame.frameType == Cuint(normal_frame)
        @test frame.contentSize == Culonglong(0)
        @test frame.dictID == Cuint(0)
        @test frame.blockChecksumFlag == Cuint(0)

        prefs = CodecLz4.LZ4F_preferences_t(frame)

        @test prefs.frameInfo == frame
        @test prefs.compressionLevel == Cint(0)
        @test prefs.autoFlush == Cuint(0)
        @test prefs.reserved == (Cuint(0), Cuint(0), Cuint(0), Cuint(0))

        frame = CodecLz4.LZ4F_frameInfo_t(
            blocksizeid = max64KB,
            blockmode = block_independent,
            contentchecksum = true,
            blockchecksum = true,
            frametype = skippable_frame,
            contentsize = 100
            )

        @test frame.blockSizeID == Cuint(4)
        @test frame.blockMode == Cuint(1)
        @test frame.contentChecksumFlag == Cuint(1)
        @test frame.frameType == Cuint(1)
        @test frame.contentSize == Culonglong(100)
        @test frame.blockChecksumFlag == Cuint(1)

        prefs = CodecLz4.LZ4F_preferences_t(frame, compressionlevel=5, autoflush = true)

        @test prefs.frameInfo == frame
        @test prefs.compressionLevel == Cint(5)
        @test prefs.autoFlush == Cuint(1)
        @test prefs.reserved == (Cuint(0), Cuint(0), Cuint(0), Cuint(0))

    end

    @testset "CompressionCtx" begin
        ctx = Ref{Ptr{CodecLz4.LZ4F_cctx}}(C_NULL)

        @test_nowarn err = CodecLz4.LZ4F_createCompressionContext(ctx, version)
        @test err == 0

        @test_nowarn CodecLz4.check_context_initialized(ctx[])

        err = CodecLz4.LZ4F_freeCompressionContext(ctx[])
        @test err == 0
        @test !CodecLz4.LZ4F_isError(err)

        ctx = Ptr{CodecLz4.LZ4F_cctx}(C_NULL)
        @test_throws CodecLz4.LZ4Exception CodecLz4.check_context_initialized(ctx)
    end


    @testset "DecompressionCtx" begin
        dctx = Ref{Ptr{CodecLz4.LZ4F_dctx}}(C_NULL)

        @test_nowarn err = CodecLz4.LZ4F_createDecompressionContext(dctx, version)
        @test err == 0

        @test_nowarn CodecLz4.check_context_initialized(dctx[])

        @test_nowarn CodecLz4.LZ4F_resetDecompressionContext(dctx[])

        err = CodecLz4.LZ4F_freeDecompressionContext(dctx[])
        @test err == 0

        dctx = Ptr{CodecLz4.LZ4F_dctx}(C_NULL)
        @test_throws CodecLz4.LZ4Exception CodecLz4.check_context_initialized(dctx)
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_resetDecompressionContext(dctx)

    end

    function test_decompress(origsize, buffer)
        @testset "Decompress" begin
            dctx = Ref{Ptr{CodecLz4.LZ4F_dctx}}(C_NULL)
            srcsize = Ref{Csize_t}(origsize)
            dstsize =  Ref{Csize_t}(8*1280)
            decbuffer = Vector{UInt8}(undef, 1280)

            frameinfo = Ref(CodecLz4.LZ4F_frameInfo_t())

            @test_nowarn err = CodecLz4.LZ4F_createDecompressionContext(dctx, version)

            @test_nowarn result = CodecLz4.LZ4F_getFrameInfo(dctx[], frameinfo, buffer, srcsize)
            @test srcsize[] > 0

            offset = srcsize[]
            srcsize[] = origsize - offset

            @test_nowarn result = CodecLz4.LZ4F_decompress(dctx[], decbuffer, dstsize, pointer(buffer) + offset, srcsize, C_NULL)
            @test srcsize[] > 0

            @test test_in == unsafe_string(pointer(decbuffer), dstsize[])

            result = CodecLz4.LZ4F_freeDecompressionContext(dctx[])
            @test !CodecLz4.LZ4F_isError(result)
        end

    end

    function test_invalid_decompress(origsize, buffer)
        @testset "DecompressInvalid" begin

            dctx = Ref{Ptr{CodecLz4.LZ4F_dctx}}(C_NULL)
            srcsize = Ref{Csize_t}(origsize)
            dstsize =  Ref{Csize_t}(1280)
            decbuffer = Vector{UInt8}(undef, 1280)

            frameinfo = Ref(CodecLz4.LZ4F_frameInfo_t())

            CodecLz4.LZ4F_createDecompressionContext(dctx, version)

            buffer[1:CodecLz4.LZ4F_HEADER_SIZE_MAX] .= 0x10
            @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_getFrameInfo(dctx[], frameinfo, buffer, srcsize)

            offset = srcsize[]
            srcsize[] = origsize - offset

            @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_decompress(dctx[], decbuffer, dstsize, pointer(buffer) + offset, srcsize, C_NULL)

            result = CodecLz4.LZ4F_freeDecompressionContext(dctx[])
            @test !CodecLz4.LZ4F_isError(result)
        end
    end

    @testset "Compress" begin
        ctx = Ref{Ptr{CodecLz4.LZ4F_cctx}}(C_NULL)
        err = CodecLz4.LZ4F_isError(CodecLz4.LZ4F_createCompressionContext(ctx, version))
        @test !err

        prefs = Ptr{CodecLz4.LZ4F_preferences_t}(C_NULL)

        bound = CodecLz4.LZ4F_compressBound(test_size, prefs)
        @test bound > 0

        bufsize = bound + CodecLz4.LZ4F_HEADER_SIZE_MAX
        buffer = Vector{UInt8}(undef, ceil(Int, bound / 8))

        @test_nowarn result = CodecLz4.LZ4F_compressBegin(ctx[], buffer, bufsize, prefs)

        offset = result
        @test_nowarn result = CodecLz4.LZ4F_compressUpdate(ctx[], pointer(buffer) + offset, bufsize - offset, pointer(test_in), test_size, C_NULL)

        offset += result
        @test_nowarn result = CodecLz4.LZ4F_flush(ctx[], pointer(buffer)+offset, bufsize - offset, C_NULL)

        offset += result
        @test_nowarn result = CodecLz4.LZ4F_compressEnd(ctx[], pointer(buffer)+offset, bufsize - offset, C_NULL)
        @test result > 0

        offset += result

        result = CodecLz4.LZ4F_freeCompressionContext(ctx[])
        @test !CodecLz4.LZ4F_isError(result)

        test_decompress(offset, buffer)
        test_invalid_decompress(offset, buffer)
    end

    @testset "CompressUninitialized" begin
        ctx = Ref{Ptr{CodecLz4.LZ4F_cctx}}(C_NULL)

        prefs = Ptr{CodecLz4.LZ4F_preferences_t}(C_NULL)

        bufsize = test_size
        buffer = Vector{UInt8}(undef, test_size)

        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_compressBegin(ctx[], buffer, bufsize, prefs)
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_compressUpdate(ctx[], pointer(buffer), bufsize, pointer(test_in), test_size, C_NULL)
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_flush(ctx[], pointer(buffer), bufsize, C_NULL)
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_compressEnd(ctx[], pointer(buffer), bufsize, C_NULL)
    end

    @testset "CompressInvalid" begin
        ctx = Ref{Ptr{CodecLz4.LZ4F_cctx}}(C_NULL)
        CodecLz4.LZ4F_createCompressionContext(ctx, version)

        prefs = Ptr{CodecLz4.LZ4F_preferences_t}(C_NULL)

        bound = CodecLz4.LZ4F_compressBound(test_size, prefs)
        @test bound > 0

        bufsize = bound + CodecLz4.LZ4F_HEADER_SIZE_MAX
        buffer = Vector{UInt8}(undef, ceil(Int, bound / 8))

        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_compressBegin(ctx[], buffer, UInt(2), prefs)
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_compressUpdate(ctx[], pointer(buffer), bufsize, pointer(test_in), test_size, C_NULL)

        result = CodecLz4.LZ4F_freeCompressionContext(ctx[])
        @test !CodecLz4.LZ4F_isError(result)


        ctx = Ref{Ptr{CodecLz4.LZ4F_cctx}}(C_NULL)
        CodecLz4.LZ4F_createCompressionContext(ctx, version)

        @test_nowarn result = CodecLz4.LZ4F_compressBegin(ctx[], buffer, bufsize, prefs)

        offset = result
        @test_nowarn result = CodecLz4.LZ4F_compressUpdate(ctx[], pointer(buffer) + offset, bufsize - offset, pointer(test_in), test_size, C_NULL)

        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_flush(ctx[], pointer(buffer), UInt(2), C_NULL)
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_compressEnd(ctx[], pointer(buffer), UInt(2), C_NULL)

        result = CodecLz4.LZ4F_freeCompressionContext(ctx[])
        @test !CodecLz4.LZ4F_isError(result)
    end

    @testset "DecompressUninitialized" begin
        dctx = Ref{Ptr{CodecLz4.LZ4F_dctx}}(C_NULL)
        srcsize = Ref{Csize_t}(test_size)
        dstsize =  Ref{Csize_t}(8*1280)
        decbuffer = Vector{UInt8}(undef, 1280)

        frameinfo = Ref(CodecLz4.LZ4F_frameInfo_t())
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_getFrameInfo(dctx[], frameinfo, pointer(test_in), srcsize)
        @test_throws CodecLz4.LZ4Exception CodecLz4.LZ4F_decompress(dctx[], decbuffer, dstsize, pointer(test_in), srcsize, C_NULL)
    end

    @testset "Preferences" begin
        ctx = Ref{Ptr{CodecLz4.LZ4F_cctx}}(C_NULL)
        err = CodecLz4.LZ4F_isError(CodecLz4.LZ4F_createCompressionContext(ctx, version))
        @test !err
        opts = Ref(CodecLz4.LZ4F_compressOptions_t(1, (0, 0, 0)))
        prefs = Ref(CodecLz4.LZ4F_preferences_t(CodecLz4.LZ4F_frameInfo_t(), 20, 0, (0, 0, 0, 0)))

        bound = CodecLz4.LZ4F_compressBound(test_size, prefs)
        @test bound > 0

        bufsize = bound + CodecLz4.LZ4F_HEADER_SIZE_MAX
        buffer = Vector{UInt8}(undef, ceil(Int, bound / 8))

        @test_nowarn result = CodecLz4.LZ4F_compressBegin(ctx[], buffer, bufsize, prefs)

        offset = result
        @test_nowarn result = CodecLz4.LZ4F_compressUpdate(ctx[], pointer(buffer) + offset, bufsize - offset, pointer(test_in), test_size, opts)

        offset += result
        @test_nowarn result = CodecLz4.LZ4F_flush(ctx[], pointer(buffer) + offset, bufsize - offset, opts)

        offset += result
        @test_nowarn result = CodecLz4.LZ4F_compressEnd(ctx[], pointer(buffer) + offset, bufsize - offset, opts)
        @test result > 0

        offset += result

        result = CodecLz4.LZ4F_freeCompressionContext(ctx[])
        @test !CodecLz4.LZ4F_isError(result)

        test_decompress(offset, buffer)
    end

end

mutable struct SimpleRingBuffer
    buffer::Vector{UInt8}
    offset::Int
end

SimpleRingBuffer(buf_size::Integer) = SimpleRingBuffer(Vector{UInt8}(undef, buf_size), 0)
Base.pointer(buf::SimpleRingBuffer) = pointer(buf.buffer) + buf.offset
reset!(buf::SimpleRingBuffer) = buf.offset = 0

function copy_data!(dest::SimpleRingBuffer, src::Memory, data_size::Integer)
    checkbounds(src, data_size)
    if length(dest.buffer) < data_size
        throw(ArgumentError(
            "Cannot store $data_size bytes in buffer of size $(length(dest.buffer))"
        ))
    end

    if dest.offset + data_size > length(dest.buffer)
        dest.offset = 0
    end
    data_start = pointer(dest)
    unsafe_copyto!(data_start, src.ptr, data_size)

    dest.offset += data_size
    return data_start
end

mutable struct LZ4HCCompressor <: TranscodingStreams.Codec
    streamptr::Ptr{LZ4_streamHC_t}
    compressionlevel::Cint
    block_size::Int
    buffer::SimpleRingBuffer
end

"""
    LZ4HCCompressor(; kwargs...)

Creates an LZ4 HC compression codec.

# Keywords
- `compressionlevel::Integer=$LZ4HC_CLEVEL_DEFAULT`: compression level
- `block_size::Integer=1024`: The size in bytes to encrypt into each block. (Max 4MB)
"""
function LZ4HCCompressor(;
    compressionlevel::Integer=LZ4HC_CLEVEL_DEFAULT,
    block_size::Integer=1024
)
    if block_size > LZ4_MAX_INPUT_SIZE
        throw(ArgumentError("`block_size` larger than $LZ4_MAX_INPUT_SIZE."))
    end

    return LZ4HCCompressor(
        C_NULL,
        compressionlevel,
        block_size,
        SimpleRingBuffer(4 * block_size),
    )
end

const LZ4HCCompressorStream{S} = TranscodingStream{LZ4HCCompressor,S} where S<:IO

"""
    LZ4HCCompressorStream(stream::IO; kwargs...)

Creates an LZ4 HC compression stream.
See `LZ4HCCompressorStream()` and `TranscodingStream()` for arguments.
"""
function LZ4HCCompressorStream(stream::IO; kwargs...)
    x, y = splitkwargs(kwargs, (:compressionlevel, :block_size))
    return TranscodingStream(LZ4HCCompressor(; x...), stream; y...)
end

"""
   TranscodingStreams.initialize(codec::LZ4HCCompressor)

Initializes the LZ4 HC compression Codec.
"""
function TranscodingStreams.initialize(codec::LZ4HCCompressor)::Nothing
    codec.streamptr = LZ4_createStreamHC()
    nothing
end

"""
    TranscodingStreams.expectedsize(codec::Union{LZ4FastCompressor, LZ4HCCompressor}, input::Memory)

Returns the expected size of the transcoded data.
"""
function TranscodingStreams.expectedsize(codec::LZ4HCCompressor, input::Memory)::Int
    max_compressed_size(length(input), codec.block_size)
end

"""
   TranscodingStreams.minoutsize(codec::Union{LZ4FastCompressor, LZ4HCCompressor}, input::Memory)

Returns the minimum output size of `process`.
"""
function TranscodingStreams.minoutsize(codec::LZ4HCCompressor, input::Memory)::Int
    LZ4_compressBound(length(input)) + CINT_SIZE
end

"""
    TranscodingStreams.finalize(codec::LZ4HCCompressor)

Finalizes the LZHC Compression Codec.
"""
function TranscodingStreams.finalize(codec::LZ4HCCompressor)::Nothing
    LZ4_freeStreamHC(codec.streamptr)
    codec.streamptr = C_NULL
    nothing
end

"""
    TranscodingStreams.startproc(codec::LZ4HCCompressor, mode::Symbol, error::Error)

Starts processing with the codec
"""
function TranscodingStreams.startproc(
    codec::LZ4HCCompressor,
    mode::Symbol,
    error::Error
)::Symbol

    try
        LZ4_resetStreamHC(codec.streamptr, codec.compressionlevel)
        reset!(codec.buffer)
        :ok
    catch err
        error[] = err
        :error
    end
end

"""
    TranscodingStreams.process(codec::LZ4HCCompressor, input::Memory, output::Memory, error::Error)

Compresses the data from `input` and writes to `output`.
The process follows the compression example from
https://github.com/lz4/lz4/blob/dev/examples/HCStreaming_ringBuffer.c
wherein each block of encoded data is prefixed by the number of bytes contained in that block.
Decoding can be done through the LZ4SafeDecompressor.
"""
function TranscodingStreams.process(
    codec::LZ4HCCompressor,
    input::Memory,
    output::Memory,
    error::Error
)::Tuple{Int,Int,Symbol}

    length(input) == 0 && return (0, 0, :end)
    try
        data_size = min(length(input), codec.block_size)

        in_buffer = copy_data!(codec.buffer, input, data_size)
        out_buffer = Vector{UInt8}(undef, LZ4_compressBound(data_size))

        compressed_size = LZ4_compress_HC_continue(
            codec.streamptr,
            in_buffer,
            pointer(out_buffer),
            data_size,
            length(out_buffer)
        )

        checkbounds(output, compressed_size + CINT_SIZE)
        writeint(output, compressed_size)
        unsafe_copyto!(output.ptr+CINT_SIZE, pointer(out_buffer), compressed_size)

        return (data_size, compressed_size + CINT_SIZE, :ok)

    catch err
        error[] = err
        return (0, 0, :error)
    end
end

@testset "hc_compression" begin
    text = b"""
    Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean sollicitudin
    mauris non nisi consectetur, a dapibus urna pretium. Vestibulum non posuere
    erat. Donec luctus a turpis eget aliquet. Cras tristique iaculis ex, eu
    malesuada sem interdum sed. Vestibulum ante ipsum primis in faucibus orci luctus
    et ultrices posuere cubilia Curae; Etiam volutpat, risus nec gravida ultricies,
    erat ex bibendum ipsum, sed varius ipsum ipsum vitae dui.
    """

    @testset "Transcoding" begin
        @test LZ4HCCompressorStream <: TranscodingStream

        compressed = transcode(LZ4HCCompressor, text)
        @test sizeof(compressed) < sizeof(text)

        decompressed = transcode(LZ4SafeDecompressor, compressed)
        @test sizeof(decompressed) > sizeof(compressed)
        @test decompressed == Vector{UInt8}(text)

        test_roundtrip_fileio(LZ4HCCompressor, LZ4SafeDecompressor)
        test_roundtrip_transcode(LZ4HCCompressor, LZ4SafeDecompressor)

        file = IOBuffer(text)
        stream = LZ4SafeDecompressorStream(LZ4HCCompressorStream(file))
        flush(stream)

        @test read(stream) == text
        close(stream)
        close(file)

        file = IOBuffer(text)
        stream = LZ4SafeDecompressorStream(LZ4HCCompressorStream(file; compressionlevel = 5))
        flush(stream)

        @test read(stream) == text
        close(stream)
        close(file)


        file = IOBuffer("")
        stream = LZ4SafeDecompressorStream(LZ4HCCompressorStream(file))
        flush(stream)

        @test read(stream) == b""
        close(stream)
        close(file)

        teststring = rand(UInt8, 10000)
        file = IOBuffer(teststring)
        stream = LZ4SafeDecompressorStream(LZ4HCCompressorStream(file; block_size = 2048); block_size = 2048)
        flush(stream)

        @test read(stream) == teststring
        close(stream)
        close(file)
    end

    @testset "Errors" begin
        # Uninitialized
        input_data = Vector{UInt8}(text)
        output_data = Vector{UInt8}(undef, 1280)
        GC.@preserve input_data output_data begin
            input = Memory(pointer(input_data), length(input_data))
            output = Memory(pointer(output_data), length(output_data))
            not_initialized = LZ4HCCompressor()
            @test TranscodingStreams.startproc(not_initialized, :read, Error()) == :error
            @test TranscodingStreams.process(not_initialized, input, output, Error()) == (0, 0, :error)

            # Compression into too-small buffer
            output = Memory(pointer(output_data), 1)
            compressor = LZ4HCCompressor()
            try
                @test_nowarn TranscodingStreams.initialize(compressor)
                @test TranscodingStreams.startproc(compressor, :read, Error()) == :ok
                err = Error()
                @test TranscodingStreams.process(compressor, input, output, err) == (0, 0, :error)

                @test err[] isa BoundsError
            finally
                TranscodingStreams.finalize(compressor)
            end
        end

        # Block size too large
        @test_throws ArgumentError LZ4HCCompressor(; block_size = CodecLz4.LZ4_MAX_INPUT_SIZE + 1)
    end

    @testset "dst size fix" begin
        teststring = rand(UInt8, 800000)
        io = IOBuffer(teststring)
        stream = LZ4HCCompressorStream(io)
        result = read(stream)
        @test_nowarn close(stream)
        close(io)

        io = IOBuffer(result)
        stream = LZ4SafeDecompressorStream(io)
        result = read(stream)
        @test result == teststring
        @test_nowarn close(stream)
        close(io)
    end

end

using Documenter, CodecLz4

makedocs(;
    modules=[CodecLz4],
    pages=[
        "Home" => "index.md",
    ],
    sitename="CodecLz4.jl",
    authors="Invenia Technical Computing Corporation",
)

deploydocs(;
    repo="github.com/JuliaIO/CodecLz4.jl",
)

@testset "lz4_compression" begin
    text = b"""
    Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean sollicitudin
    mauris non nisi consectetur, a dapibus urna pretium. Vestibulum non posuere
    erat. Donec luctus a turpis eget aliquet. Cras tristique iaculis ex, eu
    malesuada sem interdum sed. Vestibulum ante ipsum primis in faucibus orci luctus
    et ultrices posuere cubilia Curae; Etiam volutpat, risus nec gravida ultricies,
    erat ex bibendum ipsum, sed varius ipsum ipsum vitae dui.
    """

    @testset "Transcoding" begin
        @test LZ4FastCompressorStream <: TranscodingStream
        @test LZ4SafeDecompressorStream <: TranscodingStream

        compressed = transcode(LZ4FastCompressor, text)
        @test sizeof(compressed) < sizeof(text)

        decompressed = transcode(LZ4SafeDecompressor, compressed)
        @test sizeof(decompressed) > sizeof(compressed)
        @test decompressed == Vector{UInt8}(text)

        test_roundtrip_fileio(LZ4FastCompressor, LZ4SafeDecompressor)
        test_roundtrip_transcode(LZ4FastCompressor, LZ4SafeDecompressor)

        file = IOBuffer(text)
        stream = LZ4SafeDecompressorStream(LZ4FastCompressorStream(file))
        flush(stream)

        @test read(stream) == text
        close(stream)
        close(file)

        file = IOBuffer(text)
        stream = LZ4SafeDecompressorStream(LZ4FastCompressorStream(file; acceleration = 5))
        flush(stream)

        @test read(stream) == text
        close(stream)
        close(file)

        file = IOBuffer("")
        stream = LZ4SafeDecompressorStream(LZ4FastCompressorStream(file))
        flush(stream)

        @test read(stream) == b""
        close(stream)
        close(file)

        teststring = rand(UInt8, 10000)
        file = IOBuffer(teststring)
        stream = LZ4SafeDecompressorStream(LZ4FastCompressorStream(file; block_size = 2048); block_size = 2048)
        flush(stream)

        @test read(stream) == teststring
        close(stream)
        close(file)
    end

    @testset "Errors" begin
        @testset "Uninitialized" begin
            input_data = Vector{UInt8}(text)
            output_data = Vector{UInt8}(undef, 1280)
            GC.@preserve input_data output_data begin
                input = Memory(pointer(input_data), length(input_data))
                output = Memory(pointer(output_data), length(output_data))
                not_initialized = LZ4FastCompressor()
                @test TranscodingStreams.startproc(not_initialized, :read, Error()) == :error
                @test TranscodingStreams.process(not_initialized, input, output, Error()) == (0, 0, :error)

                compressed_data = transcode(LZ4FastCompressor, text)
                GC.@preserve compressed_data begin
                    compressed = Memory(pointer(compressed_data), length(compressed_data))
                    not_initialized = LZ4SafeDecompressor()
                    @test TranscodingStreams.startproc(not_initialized, :read, Error()) == :error
                    @test TranscodingStreams.process(not_initialized, compressed, output, Error()) == (0, 0, :error)
                end
            end
        end

        @testset "Bad Input" begin
            # Malformed decompression input
            @test_throws CodecLz4.LZ4Exception transcode(LZ4SafeDecompressor, text)
            @test_throws BoundsError transcode(LZ4SafeDecompressor, [0x00])

            # Properly compressed but not formatted as a stream
            compressed = lz4_compress(text)
            @test_throws CodecLz4.LZ4Exception transcode(LZ4SafeDecompressor, text)

            # Block size too large
            @test_throws ArgumentError LZ4FastCompressor(; block_size = CodecLz4.LZ4_MAX_INPUT_SIZE + 1)
        end

        @testset "Bad Buffer Size" begin
            # Decompression with too-small block_size
            output_data = Vector{UInt8}(undef, 1024)
            compressed_data = transcode(LZ4FastCompressor, text)
            GC.@preserve output_data compressed_data begin
                output = Memory(pointer(output_data), length(output_data))
                compressed = Memory(pointer(compressed_data), length(compressed_data))
                decompressor = LZ4SafeDecompressor(; block_size = 200)
                try
                    @test_nowarn TranscodingStreams.initialize(decompressor)
                    @test TranscodingStreams.startproc(decompressor, :read, Error()) == :ok
                    err = Error()
                    @test TranscodingStreams.process(decompressor, compressed, output, err) == (0, 0, :error)

                    @test err[] isa CodecLz4.LZ4Exception
                    @test err[].msg == "Decompression failed."
                finally
                    TranscodingStreams.finalize(decompressor)
                end
            end

            # Compression into too-small buffer
            input_data = Vector{UInt8}(text)
            output_data = Vector{UInt8}(undef, 1)
            GC.@preserve input_data output_data begin
                input = Memory(pointer(input_data), length(input_data))
                output = Memory(pointer(output_data), length(output_data))
                compressor = LZ4FastCompressor()

                try
                    @test_nowarn TranscodingStreams.initialize(compressor)
                    @test TranscodingStreams.startproc(compressor, :read, Error()) == :ok
                    err = Error()
                    @test TranscodingStreams.process(compressor, input, output, err) == (0, 0, :error)

                    @test err[] isa BoundsError
                finally
                    TranscodingStreams.finalize(compressor)
                end
            end

            # Decompression into too-small buffer
            output_data = Vector{UInt8}(undef, 1)
            compressed_data = transcode(LZ4FastCompressor, text)
            GC.@preserve output_data compressed_data begin
                output = Memory(pointer(output_data), length(output_data))
                compressed = Memory(pointer(compressed_data), length(compressed_data))
                decompressor = LZ4SafeDecompressor()
                try
                    @test_nowarn TranscodingStreams.initialize(decompressor)
                    @test TranscodingStreams.startproc(decompressor, :read, Error()) == :ok
                    err = Error()
                    @test TranscodingStreams.process(decompressor, compressed, output, err) == (0, 0, :error)

                    @test err[] isa BoundsError
                finally
                    TranscodingStreams.finalize(decompressor)
                end
            end
        end
    end

    @testset "dst size fix" begin
        teststring = rand(UInt8, 800000)
        io = IOBuffer(teststring)
        stream = LZ4FastCompressorStream(io)
        result = read(stream)
        @test_nowarn close(stream)
        close(io)

        io = IOBuffer(result)
        stream = LZ4SafeDecompressorStream(io)
        result = read(stream)
        @test result == teststring
        @test_nowarn close(stream)
        close(io)
    end
end

using TranscodingStreams: TranscodingStream, Error, Memory
using TestsForCodecPackages: test_roundtrip_fileio, test_roundtrip_transcode
using TranscodingStreams

text = b"""
Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean sollicitudin
mauris non nisi consectetur, a dapibus urna pretium. Vestibulum non posuere
erat. Donec luctus a turpis eget aliquet. Cras tristique iaculis ex, eu
malesuada sem interdum sed. Vestibulum ante ipsum primis in faucibus orci luctus
et ultrices posuere cubilia Curae; Etiam volutpat, risus nec gravida ultricies,
erat ex bibendum ipsum, sed varius ipsum ipsum vitae dui.
"""

@testset "Transcoding" begin
    @test LZ4FrameCompressorStream <: TranscodingStream
    @test LZ4FrameDecompressorStream <: TranscodingStream

    compressed = transcode(LZ4FrameCompressor, text)
    @test sizeof(compressed) < sizeof(text)

    decompressed = transcode(LZ4FrameDecompressor, compressed)
    @test sizeof(decompressed) > sizeof(compressed)
    @test decompressed == Vector{UInt8}(text)

    test_roundtrip_fileio(LZ4FrameCompressor, LZ4FrameDecompressor)
    test_roundtrip_transcode(LZ4FrameCompressor, LZ4FrameDecompressor)

    file = IOBuffer(text)
    stream = LZ4FrameDecompressorStream(LZ4FrameCompressorStream(file))
    flush(stream)

    @test hash(read(stream)) == hash(text)
    close(stream)
    close(file)

    file = IOBuffer(text)
    stream = LZ4FrameDecompressorStream(LZ4FrameCompressorStream(file; blocksizeid = max64KB))
    flush(stream)

    @test hash(read(stream)) == hash(text)
    close(stream)
    close(file)


    file = IOBuffer("")
    stream = LZ4FrameDecompressorStream(LZ4FrameCompressorStream(file))
    flush(stream)

    @test hash(read(stream)) == hash(b"")
    close(stream)
    close(file)
end

@testset "Errors" begin
    input_data = Vector{UInt8}(text)
    output_data = Vector{UInt8}(undef, 1280)
    GC.@preserve input_data output_data begin
        input = Memory(pointer(input_data), length(input_data))
        output = Memory(pointer(output_data), length(output_data))
        not_initialized = LZ4FrameCompressor()
        @test TranscodingStreams.startproc(not_initialized, :read, Error()) == :error
        @test TranscodingStreams.process(not_initialized, input, output, Error()) == (0, 0, :error)

        compressed = transcode(LZ4FrameCompressor, Vector{UInt8}(text))
        corrupted = copy(compressed)
        corrupted[1] = 0x00
        file = IOBuffer(corrupted)
        stream = LZ4FrameDecompressorStream(file)
        @test_throws CodecLz4.LZ4Exception read(stream)
        @test_throws ArgumentError read(stream)

        output = Memory(pointer(output_data), 1)
        compressor = LZ4FrameCompressor()
        @test_nowarn TranscodingStreams.initialize(compressor)
        @test TranscodingStreams.startproc(compressor, :read, Error()) == :ok
        err = Error()
        @test TranscodingStreams.process(compressor, input, output, err) == (0, 0, :error)
        @test err[].msg == "Output buffer too small for header."
        @test_nowarn TranscodingStreams.finalize(compressor)
    end

    codec = LZ4FrameDecompressor()
    @test_throws CodecLz4.LZ4Exception transcode(codec, "not properly formatted")
    @test_nowarn TranscodingStreams.finalize(codec)
end

@testset "keywords" begin
    compressor = LZ4FrameCompressor(
        blocksizeid = max64KB,
        blockmode = block_independent,
        contentchecksum = true,
        blockchecksum = true,
        frametype = skippable_frame,
        contentsize = 100,
        compressionlevel=5,
        autoflush = true
        )

    prefs = compressor.prefs[]
    @test prefs.compressionLevel == Cint(5)
    @test prefs.autoFlush == Cuint(1)
    @test prefs.reserved == (Cuint(0), Cuint(0), Cuint(0), Cuint(0))

    frame = prefs.frameInfo
    @test frame.blockSizeID == Cuint(4)
    @test frame.blockMode == Cuint(1)
    @test frame.contentChecksumFlag == Cuint(1)
    @test frame.frameType == Cuint(1)
    @test frame.contentSize == Culonglong(100)
    @test frame.blockChecksumFlag == Cuint(1)
end

@testset "dst size fix" begin
    teststring = rand(UInt8, 800000)
    io = IOBuffer(teststring)
    stream = LZ4FrameCompressorStream(io)
    result = read(stream)
    @test_nowarn close(stream)
    close(io)

    io = IOBuffer(result)
    stream = LZ4FrameDecompressorStream(io)
    result = read(stream)
    @test result == teststring
    @test_nowarn close(stream)
    close(io)
end

test_in = b"""
    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
    incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud
    exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat
    """

@testset "simple_compression" begin
    comp = lz4_compress(test_in, 5)
    @test comp != test_in

    decomp = lz4_decompress(comp)
    @test decomp == test_in

    comp = lz4_hc_compress(test_in, 12)
    @test comp != test_in
    decomp = lz4_decompress(comp)
    @test decomp == test_in

    huge_vector = rand(UInt8, CodecLz4.LZ4_MAX_INPUT_SIZE + 1)
    @test_throws CodecLz4.LZ4Exception lz4_hc_compress(huge_vector)
    @test_throws CodecLz4.LZ4Exception lz4_compress(huge_vector)
    @test_throws CodecLz4.LZ4Exception lz4_decompress(comp, floor(Int, length(test_in)/2))
    @test_throws CodecLz4.LZ4Exception lz4_decompress(test_in)
end

using TranscodingStreams: splitkwargs

const BUF_SIZE = 16*1024
const LZ4_FOOTER_SIZE = 4

mutable struct LZ4FrameCompressor <: TranscodingStreams.Codec
    ctx::Ptr{LZ4F_cctx}
    prefs::Base.RefValue{LZ4F_preferences_t}
    header::Vector{UInt8}
    write_header::Bool
end

"""
    LZ4FrameCompressor(; kwargs...)

Creates an LZ4 compression codec.

# Keywords
- `blocksizeid::BlockSizeID=default_size`: `max64KB`, `max256KB`, `max1MB`, or `max4MB` or `default_size`
- `blockmode::BlockMode=block_linked`:  `block_linked` or `block_independent`
- `contentchecksum::Bool=false`: if `true`, frame is terminated with a
    32-bits checksum of decompressed data
- `frametype::FrameType=normal_frame)`:  `normal_frame` or `skippable_frame`
- `contentsize::Integer=0`: Size of uncompressed content (0 for unknown)
- `blockchecksum::Bool=false`: if `true`, each block is followed by a
    checksum of block's compressed data
- `compressionlevel::Integer=0`: compression level (-1..12)
- `autoflush::Bool=false`: always flush if `true`
"""
function LZ4FrameCompressor(; kwargs...)
    x, y = splitkwargs(kwargs, (:compressionlevel, :autoflush))
    ctx = Ptr{LZ4F_cctx}(C_NULL)
    frame = LZ4F_frameInfo_t(; y...)
    prefs = Ref(LZ4F_preferences_t(frame; x...))
    return LZ4FrameCompressor(ctx, prefs, Vector{UInt8}(undef, LZ4F_HEADER_SIZE_MAX), false)
end

const LZ4FrameCompressorStream{S} = TranscodingStream{LZ4FrameCompressor,S} where S<:IO

"""
    LZ4FrameCompressorStream(stream::IO; kwargs...)

Creates an LZ4 compression stream. See `LZ4FrameCompressor()` and `TranscodingStream()` for arguments.
"""
function LZ4FrameCompressorStream(stream::IO; kwargs...)
    x, y = splitkwargs(kwargs, (:blocksizeid, :blockmode, :contentchecksum, :blockchecksum, :frametype, :contentsize, :compressionlevel, :autoflush))
    return TranscodingStream(LZ4FrameCompressor(; x...), stream; y...)
end

"""
    TranscodingStreams.expectedsize(codec::LZ4FrameCompressor, input::Memory)

Returns the expected size of the transcoded data.
"""
function TranscodingStreams.expectedsize(codec::LZ4FrameCompressor, input::Memory)::Int
    LZ4F_compressBound(length(input), codec.prefs) + LZ4F_HEADER_SIZE_MAX + LZ4_FOOTER_SIZE
end

"""
   TranscodingStreams.minoutsize(codec::LZ4FrameCompressor, input::Memory)

Returns the minimum output size of `process`.
"""
function TranscodingStreams.minoutsize(codec::LZ4FrameCompressor, input::Memory)::Int
    LZ4F_compressBound(length(input), codec.prefs)
end

"""
   TranscodingStreams.initialize(codec::LZ4FrameCompressor)

Initializes the LZ4F Compression Codec.
"""
function TranscodingStreams.initialize(codec::LZ4FrameCompressor)::Nothing
    cctxPtr = Ref{Ptr{LZ4F_cctx}}(C_NULL)
    LZ4F_createCompressionContext(cctxPtr, LZ4F_getVersion())
    codec.ctx = cctxPtr[]
    nothing
end

"""
    TranscodingStreams.finalize(codec::LZ4FrameCompressor)

Finalizes the LZ4F Compression Codec.
"""
function TranscodingStreams.finalize(codec::LZ4FrameCompressor)::Nothing
    LZ4F_freeCompressionContext(codec.ctx)
    codec.ctx = C_NULL
    nothing
end

"""
    TranscodingStreams.startproc(codec::LZ4FrameCompressor, mode::Symbol, error::Error)

Starts processing with the codec
Creates the LZ4F header to be written to the output.
"""
function TranscodingStreams.startproc(codec::LZ4FrameCompressor, mode::Symbol, error::Error)::Symbol
    try
        header = codec.header
        resize!(header, LZ4F_HEADER_SIZE_MAX)
        headerSize = LZ4F_compressBegin(codec.ctx, header, convert(Csize_t, sizeof(header)), codec.prefs)
        resize!(header, headerSize)
        codec.write_header = true
        :ok
    catch err
        error[] = err
        :error
    end
end

"""
    TranscodingStreams.process(codec::LZ4FrameCompressor, input::Memory, output::Memory, error::Error)

Compresses the data from `input` and writes to `output`.
The LZ4 compression algorithm may simply buffer the input data a full frame can be produced, so `data_written` may be 0.
`flush()` may be used to force `output` to be written.
"""
function TranscodingStreams.process(codec::LZ4FrameCompressor, input::Memory, output::Memory, error::Error)::Tuple{Int,Int,Symbol}
    data_read = 0
    data_written = 0
    if codec.write_header
        if length(output) < sizeof(codec.header)
            error[] = ErrorException("Output buffer too small for header.")
            return (data_read, data_written, :error)
        end
        data_written = sizeof(codec.header)
        GC.@preserve codec unsafe_copyto!(output.ptr, pointer(codec.header), data_written)
        codec.write_header = false
    end

    data_read = length(input)
    try
        if data_read == 0
            data_written += LZ4F_compressEnd(codec.ctx, output.ptr + data_written, length(output) - data_written, C_NULL)
            (data_read, data_written, :end)
        else
            data_written += LZ4F_compressUpdate(codec.ctx, output.ptr + data_written, length(output) - data_written, input.ptr, data_read, C_NULL)
            (data_read, data_written, :ok)
        end

    catch err
        error[] = err
        data_read = 0
        (data_read, data_written, :error)
    end

end

mutable struct LZ4FrameDecompressor <: TranscodingStreams.Codec
    dctx::Ptr{LZ4F_dctx}
end

"""
    LZ4FrameCompressor()

Creates an LZ4 decompression codec.
"""
function LZ4FrameDecompressor()
    dctx = Ptr{LZ4F_dctx}(C_NULL)
    return LZ4FrameDecompressor(dctx)
end

const LZ4FrameDecompressorStream{S} = TranscodingStream{LZ4FrameDecompressor,S} where S<:IO

"""
    LZ4FrameCompressorStream(stream::IO; kwargs...)

Creates an LZ4 decompression stream. See `TranscodingStream()` for arguments.
"""
function LZ4FrameDecompressorStream(stream::IO; kwargs...)
    return TranscodingStream(LZ4FrameDecompressor(), stream; kwargs...)
end

"""
    TranscodingStreams.initialize(codec::LZ4FrameDecompressor)

Initializes the LZ4F Decompression Codec.
"""
function TranscodingStreams.initialize(codec::LZ4FrameDecompressor)::Nothing
    dctxPtr = Ref{Ptr{LZ4F_dctx}}(C_NULL)
    LZ4F_createDecompressionContext(dctxPtr, LZ4F_getVersion())
    codec.dctx = dctxPtr[]
    nothing
end

"""
    TranscodingStreams.finalize(codec::LZ4FrameDecompressor)

Finalizes the LZ4F Decompression Codec.
"""
function TranscodingStreams.finalize(codec::LZ4FrameDecompressor)::Nothing
    LZ4F_freeDecompressionContext(codec.dctx)
    codec.dctx = C_NULL
    nothing
end

"""
    TranscodingStreams.process(codec::LZ4FrameDecompressor, input::Memory, output::Memory, error::Error)

Decompresses the data from `input` and writes to `output`.
If the input data is not properly formatted this function will throw an error.
"""
function TranscodingStreams.process(codec::LZ4FrameDecompressor, input::Memory, output::Memory, error::Error)::Tuple{Int,Int,Symbol}
    data_read = 0
    data_written = 0

    try
        if length(input) == 0
            (data_read, data_written, :end)
        else
            src_size = Ref{Csize_t}(length(input))
            dst_size = Ref{Csize_t}(length(output))
            LZ4F_decompress(codec.dctx, output.ptr, dst_size, input.ptr, src_size, C_NULL)
            (src_size[], dst_size[], :ok)
        end
    catch err
        if isa(err, LZ4Exception) && err.msg == "ERROR_frameType_unknown"
            codec.dctx = C_NULL
        end
        error[] = err
        (data_read, data_written, :error)
    end

end

# CodecLz4

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaio.github.io/CodecLz4.jl/stable)
[![Latest](https://img.shields.io/badge/docs-latest-blue.svg)](https://juliaio.github.io/CodecLz4.jl/latest)
[![Build Status](https://github.com/JuliaIO/CodecLz4.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/JuliaIO/CodecLz4.jl/actions/workflows/CI.yml)
[![CodeCov](https://codecov.io/gh/JuliaIO/CodecLz4.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaIO/CodecLz4.jl)

```@autodocs
Modules = [CodecLz4]
```
